@ECHO OFF

SET defusername=admin
SET defpassword=admin
SET yafuflashpath=.\Win\Yafuflash.exe

:begin
for /f "delims=" %%A in ('dir ".\Image\*.ima" /b') do set "imagepath=%%A"

cd Win

ECHO ====================================================
ECHO =            BMC firmware update tool              =
ECHO ====================================================

ECHO Image file name: %imagepath%


If "%1"=="" (
	ECHO Usage: %0 [ip address] 
	pause
	goto end
)

If "%1"=="-local" (
	If "%2"=="-p" (Yafuflash.exe -kcs ..\Image\%imagepath% -preserve-config -force-boot)
	If "%2"=="-preserve" (Yafuflash.exe -kcs ..\Image\%imagepath% -preserve-config -force-boot)
	If "%2"=="-preserve-config" (Yafuflash.exe -kcs ..\Image\%imagepath% -preserve-config -force-boot)
	If "%2"=="" (Yafuflash.exe -kcs ..\Image\%imagepath% -force-boot)
	pause
	goto end
)

If "%1"=="-cd" (
	.\Win\Yafuflash.exe -cd .\Image\%imagepath% -force-boot
	pause
	goto end
)

SET ipaddr=%1

For /f "delims=^. tokens=1-4" %%i in ('ECHO %ipaddr: =%^|Findstr /V "\<[0][0-9] \.[0\.][0-9] [^0-9\.] [0-9]*\.[0-9]*\.[0-9]*\.[0-9]*\. ^[0-9]*\.*[0-9]*\.*[0-9]*\.*$"') Do (
    Set /A Reutrn="(%%i>>8)|(%%j>>8)|(%%k>>8)|(%%l>>8)"
    Set IP=%%i.%%j.%%k.%%l
)

If "%Reutrn%" EQU "0" (
	ECHO IP is legitimate:%IP%
) Else (
	ECHO IP is invalid:%IP%
	goto end
)

If "%2"=="" (SET username=%defusername%) Else (SET username=%2)

If "%3"=="" (SET password=%defpassword%) Else (SET password=%3)

If "%4"=="-p" (Yafuflash.exe -nw -ip %ipaddr% -U %username% -P %password%  ..\Image\%imagepath% -preserve-config -force-boot)

If "%4"=="-preserve" (Yafuflash.exe -nw -ip %ipaddr% -U %username% -P %password%  ..\Image\%imagepath% -preserve-config -force-boot)

If "%4"=="-preserve-config" (Yafuflash.exe -nw -ip %ipaddr% -U %username% -P %password%  ..\Image\%imagepath% -preserve-config -force-boot)

If "%4"=="" (Yafuflash.exe -nw -ip %ipaddr% -U %username% -P %password%  ..\Image\%imagepath% -force-boot)

pause

:end
cd ..
